/*** 襭 ࠢ ⮤  - ठ ***/
#include <math.h>
#define GAUSS_ACCURACY 0.0000001
#define GAUSS_OK 0
#define GAUSS_NOSOL 1
#define GAUSS_MANYSOL 2

/*********************************************/
/* 㭪 襭 ⥬  ࠢ */
/* ⮤  - ठ                  */
/* (C) 2002 ᪮ ᥩ                   */
/*  2.1                                */
/*********************************************/
/*   */
/* a[20][20] -   ࠭ ⥬ a[y][x]
	       ᫥ ⮫ -  ࠭ . 童
	       . 童 -  ࠢ 
   n - ᫮ 
   u - ᫮ ࠢ
    
   x[20] - ᨢ  ࠭ ୥ ⥬

    砥 ଠ쭮 믮  㭪
   頥 0,  砥 ࠧ訬 1
    砥 ᪮筮 ᫠ 襭 2 */
int gauss(double a[20][20], int n, int u, double x[20])
{
	int i, j, k;        /* 稪 横 */
	int sn;             /*  ப */
	double d;           /* 樥    . . */

	/*** ஢ઠ u  n ***/
	if (n > u) return 2;

	/*** ਢ  쭮  ***/
	for (j = 0; j < n; j++)
	{
		/* )  ப  訬   ⮬ */
		d = fabs(a[j][j]); sn = j;
		for (i = j; i < u; i++)
			if (fabs(a[i][j]) > d)
			{
				d = fabs(a[i][j]);
				sn = i;
			}

		/* ) ७ ப  饥  */
		for (k = 0; k <= n; k++)
		{
			d = a[sn][k];
			a[sn][k] = a[j][k];
			a[j][k] = d;
		}

		/* )  饣 -    */
		d = a[j][j];

		if (d)
			for (k = 0; k <= n; k++) a[j][k] /= d;
		else
			for (k = 0; k <= n; k++) a[j][k] = 0;

		/* ) ⠭  ப   ⠫ */
		/*       樥 */
		for (i = 0; i < u; i++)
		{
			if (i == j) continue;  /*  ண . ப */
			d = -a[i][j];
			for (k = 0; k <= n; k++) /* ⠭ */
				a[i][k] += a[j][k] * d;
		}
	}

	/*** ᫥ ୥ ***/
	/* ) ஢ઠ ⥬  ࠧ訬 */
	if (u > n)
	{
		for (i = n; i < u; i++)
		{
			k = 0;
			for (j = 0; j < n; j++)
				if (fabs(a[i][j]) > GAUSS_ACCURACY) k = 1;
			if (k == 0 && fabs(a[i][n]) > GAUSS_ACCURACY) return 1;
		}
	}

	/* )  ୥ */
	for (i = 0; i < n; i++)
	{
		x[i] = -a[i][n];
		if (a[i][i] != 1) /** ࠡ⪠ 訡 **/
		{ if (x[i])
			return GAUSS_NOSOL; /* 襭  */
		  else
			return GAUSS_MANYSOL; /* ᪮筮  襭 */
		}
		if (fabs(x[i]) < GAUSS_ACCURACY) x[i] = 0; /* 㫥 ᫨誮  . */
	}
	return GAUSS_OK; /* ଠ쭮 襭 ࠡ */
}