/**************************************
 *   C _ U R A V         2 . 0        *
 *        *
 *               *
 *    -                  *
 *                                    * 
 *                       *
 *   GUI-  WIN32             *
 *                                    *
 *   (C) 2002-2005 ᪮ ᥩ     *
 *   ᪨ 䠪          *
 **************************************/
/*       :
	ࠢ   ⢥ 
	[Cu(NH3)4]SO4*H2O=CuO+SO3+NH3+H2O
	CaSO4*0.5H2O+H2O=CaSO4*2H2O
	Cr2O7{2-}+H{+}+e=Cr{3+}+H2O
	Fe{3+}+e=Fe  ..
	 砥 ⠭  த⠬ ॠ樨  室묨 -
	(ਬ, H2O  ), ணࠬ ࠭ 訡.

	:
	1. 㫠  ⢠  ᮤঠ 
	      ()  []     *
	2.   ॠ樨  ࠢ   ⮩ ணࠬ
	    2NO2 + O3 = N2O5 + O2
	3. ࠢ   ᮤঠ  20 ⮢
	   / 
	4. ⨬ ᯮ짮 ᪮쪨 +  -  拉:
	   Sn{++} SO4{--}  . . */

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "c_urav32.h"
#include "uravproc.h"
#include "help.h"

LRESULT CALLBACK MyWndProc (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
{
        HWND hWnd;
        WNDCLASSEX WndClass;
        MSG Msg;
        char szClassName[] = "C_URAV";
        
        /* 㥬 ᮧ  */
        /* 塞  ⨯ WNDCLASS */
	WndClass.cbSize = sizeof(WndClass);
        WndClass.style = CS_HREDRAW | CS_VREDRAW;
        WndClass.lpfnWndProc = MyWndProc;
        WndClass.cbClsExtra = 0;
        WndClass.cbWndExtra = DLGWINDOWEXTRA;
        WndClass.hInstance = hInstance;
        WndClass.hIcon = LoadIcon(hInstance, szClassName);
        WndClass.hCursor = LoadCursor (NULL, IDC_ARROW);
        WndClass.hbrBackground = (HBRUSH) (COLOR_WINDOW);
        WndClass.lpszMenuName = NULL;
        WndClass.lpszClassName = szClassName;
	WndClass.hIconSm = LoadIcon(hInstance, szClassName);

        if (!RegisterClassEx(&WndClass))
        {
                MessageBox (NULL, "Cannot register class","Error",MB_OK);
                return 0;
        }

        hWnd = CreateDialog (hInstance, szClassName, 0, NULL);
        
        if (!hWnd)
        {
                MessageBox(NULL, "Cannot create window", "Error",MB_OK);
                return 0;
        }

        /* Show our window */
        ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

        /* Beginning of messages cycle */
        while (GetMessage(&Msg,NULL,0,0))
        {
                TranslateMessage(&Msg);
                DispatchMessage(&Msg);
        }
        return Msg.wParam;
}

/*  楤,  㦨
    "About the program" */
BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
		case WM_INITDIALOG:
			return TRUE;
		        break;

		case WM_COMMAND:
		switch (wParam)
		{
			case IDOK:
			case IDCANCEL:
				EndDialog (hDlg, 0);
				return TRUE;
				break;
		}
	}
	return FALSE;
}

BOOL CALLBACK HelpDlgProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
	{
		case WM_INITDIALOG:
			SetDlgItemText(hDlg, 110, helpstr);
			return TRUE;
			break;

		case WM_COMMAND:
		switch (wParam)
		{
			case IDOK:
			case IDCANCEL:
				EndDialog (hDlg, 0);
				return TRUE;
				break;
		}
	}
	return FALSE;
}


LRESULT CALLBACK MyWndProc (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{	char eq[256];
	char res[256];
	static HINSTANCE hInstance;

        switch (iMsg)
        {
		case WM_CREATE:	
			hInstance = ((LPCREATESTRUCT) lParam) -> hInstance;
	                break;

                case WM_COMMAND:
		switch(wParam)
		{	case CMD_START: 
		        GetDlgItemText(hDlg, TXT_EQ, eq, 255);
			c_urav(eq,res);
			SetDlgItemText(hDlg, TXT_RES, res);
			break;

			case CMD_CLEAR:
			SetDlgItemText(hDlg, TXT_EQ,  "");
			SetDlgItemText(hDlg, TXT_RES, "");
			break;

		        case CMD_ABOUT:
			DialogBox(hInstance, "DLG_ABOUT", hDlg, AboutDlgProc);
			break;

			case CMD_HELP:
			DialogBox(hInstance, "DLG_HELP", hDlg, HelpDlgProc);
			break;
		}


                break;

                case WM_DESTROY:
                PostQuitMessage(0);
                return 0;

                default: break;
        }

        return DefWindowProc(hDlg,iMsg,wParam,lParam);
}       